package com.client;

import com.shared.FieldVerifier;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.KeyCodes;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.RadioButton;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.FileUpload;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.PasswordTextBox;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.FormPanel;
import com.google.gwt.user.client.ui.FormPanel.SubmitEvent;
import com.google.gwt.user.client.ui.FormPanel.SubmitCompleteEvent;
import com.google.gwt.user.client.Window;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class GWT_ShowParam implements EntryPoint {

  public void onModuleLoad() {
    // Create a FormPanel and point it at a service.
    final FormPanel form = new FormPanel();
    form.setAction("http://spiegel.kutztown.edu:8080/ShowParameters/ShowParameters");

    // Set the form to use the POST method
    form.setMethod(FormPanel.METHOD_POST);

    // Create a panel to hold all of the form widgets. 
    //  Must be final because it is accessed in the submit handler
    final VerticalPanel vPanel = new VerticalPanel();
    form.setWidget(vPanel);

    // No listeners. We're submitting.

    // First item: 
    //    Need a Label for the first TextBox
    Label NameLabel=new Label("Name: ");
    // Create a TextBox, giving it a name so that it will be submitted.
    final TextBox NameBox = new TextBox();
    NameBox.setName("text");
    // Put these guys on a horizontal panel
    HorizontalPanel HPanel=new HorizontalPanel();
    HPanel.add(NameLabel);
    HPanel.add(NameBox);
    vPanel.add(HPanel);

    // The Password Box
    // Need a Label for the Password Box
    Label PassLabel=new Label("Password: ");
    // Create a TextBox, giving it a name so that it will be submitted.
    final TextBox PassBox = new PasswordTextBox();
    PassBox.setName("password");
    // Put these guys on a horizontal panel
    HPanel=new HorizontalPanel();
    HPanel.add(PassLabel);
    HPanel.add(PassBox);
    vPanel.add(HPanel);

    // Create a ListBox, giving it a name and some values to be associated with
    // its options.
    // The Select, or List Box
    // Need a Label for the List Box
    Label ListBoxLabel=new Label("Select:   ");
    ListBox Select = new ListBox();
    Select.setName("selectbox");
    Select.addItem("Option 1", "option1");
    Select.addItem("Option 2", "option2");
    Select.addItem("Option 3", "option3");
    // Put these guys on a horizontal panel
    HPanel=new HorizontalPanel();
    HPanel.add(ListBoxLabel);
    HPanel.add(Select);
    vPanel.add(HPanel);
    
    Label RadioLabel=new Label("Importance:   ");
    HPanel=new HorizontalPanel();
    HPanel.add(RadioLabel);
    RadioButton Buttons[]=new RadioButton[3];
    // Set 'em up
    Buttons[0]  = new RadioButton("radio", "Very");
    Buttons[1]  = new RadioButton("radio", "Normal");
    Buttons[2]  = new RadioButton("radio", "Not");
    for (int idx=0;idx<3;idx++)
      HPanel.add(Buttons[idx]);
    vPanel.add(HPanel);
    
    Label CommentLabel=new Label("Comment:   ");
    vPanel.add(CommentLabel);
    TextArea Comments=new TextArea();
    Comments.setCharacterWidth(20);
    Comments.setVisibleLines(6);
    vPanel.add(Comments);
    
    // Add a 'submit' button.
    vPanel.add(new Button("Submit", new ClickHandler() {
      public void onClick(ClickEvent event) {
        form.submit();
      }
    }));
    
    // Result will be displayed here
    final HTML Result=new HTML("");
    vPanel.add(Result);
    
    // Add an event handler to the form.
    form.addSubmitHandler(new FormPanel.SubmitHandler() {
      public void onSubmit(SubmitEvent event) {
        // This event is fired just before the form is submitted. We can take
        // this opportunity to perform validation.
        if (NameBox.getText().length() == 0) {
          Window.alert("The text box must not be empty");
          event.cancel();
        }
	// Clear the results box
	Result.setHTML("");
      }
    });
    form.addSubmitCompleteHandler(new FormPanel.SubmitCompleteHandler() {
      public void onSubmitComplete(SubmitCompleteEvent event) {
        // When the form submission is successfully completed, this event is
        // fired. Assuming the service returned a response of type text/html,
        // we can get the result text here (see the FormPanel documentation for
        // further explanation).
	// Window.alert(event.getResults());
	Result.setHTML(event.getResults());
      }
    });

    RootPanel.get().add(form);
  }
}


